; ________________________________________________
; |  Gestione display per timer 4 digit 16F628A  |
; |______________________________________________|
; |   Src File                                   |
; |______________________________________________|
; |   Tipo      : INC                            |
; |   Versione  : 1                              |
; |   Release   : 0                              |
; |   Autore    : Lain Walter                    |
; |   Data      :  7/08/07                       |
; |______________________________________________|

;_______________________________________________________Inizializza display
Display_Init:
;Inizializza il modulo display
;Registri modificati:
;       sistema
;       b_DISP_DATA0
;       b_DISP_DATA1
;       b_DISP_DATA2
;       b_DISP_DATA3
;metodo di chiamata:
;       CALL Display_Init
;
        MOVLF 0x1,b_DISP_DATA0          ;carica 0 nei 4 display
        MOVLF 0x1,b_DISP_DATA1
        MOVLF 0x1,b_DISP_DATA2
        MOVLF 0x1,b_DISP_DATA3
        RETURN                          ;fine

Dot_Change:
;Cambia stato del punto decimale
;Registri modificati:
;       sistema
;       b_STATO
;metodo di chiamata:
;       CALL Dot_Change
;
        BTFSC f_DOT_BLINK               ;OFF?
        GOTO $+3
        BSF f_DOT_BLINK                 ; SI --> ON
        GOTO $+2
        BCF f_DOT_BLINK                 ; NO --> OFF
        RETURN

Disp_Blink:
;fa lampeggiare il display
;Registri modificati:
;       sistema
;       b_STATO
;metodo di chiamata:
;       CALL Disp_Blink
;
        BTFSC f_DISP_BLINK               ;OFF?
        GOTO $+3
        BSF f_DISP_BLINK                 ; SI --> ON
        GOTO $+2
        BCF f_DISP_BLINK                 ; NO --> OFF
        RETURN


Led_Change:
;Cambia stato tra rosso e verde,
;Registri modificati:
;       sistema
;metodo di chiamata:
;       CALL Led_Change
;
        BTFSC c_LED_GREEN_PORT,c_LED_GREEN_PIN ;ROSSO?
        GOTO $+4
        BSF c_LED_GREEN_PORT,c_LED_GREEN_PIN ; SI --> VERDE
        BCF c_LED_RED_PORT,c_LED_RED_PIN
        GOTO $+3
        BCF c_LED_GREEN_PORT,c_LED_GREEN_PIN ; NO --> ROSSO
        BSF c_LED_RED_PORT,c_LED_RED_PIN
        RETURN

Bcd27seg:
;Converte 1 byte BCD in un carattere display
;Registri modificati:
;       sistema
;       PCL
;metodo di chiamata:
;       MOVLF dato,FSR
;       CALL Bcd27seg
;       MOVWF dato
        DECF INDF,W                     ;decrementa il dato per portarlo al valore corretto 
        ADDWF PCL,F
        RETLW CHAR_0                    ;restituisce "0"
        RETLW CHAR_1                    ;restituisce "1"
        RETLW CHAR_2                    ;restituisce "2"
        RETLW CHAR_3                    ;restituisce "3"
        RETLW CHAR_4                    ;restituisce "4"
        RETLW CHAR_5                    ;restituisce "5"
        RETLW CHAR_6                    ;restituisce "6"
        RETLW CHAR_7                    ;restituisce "7"
        RETLW CHAR_8                    ;restituisce "8"
        RETLW CHAR_9                    ;restituisce "9"
        RETLW CHAR_E                    ;errore, restituisce "E"
        RETURN

