; ________________________________________________
; |  Lettura pulsanti per timer 4 digit 16F628A  |
; |______________________________________________|
; |   Src File                                   |
; |______________________________________________|
; |   Tipo      : INC                            |
; |   Versione  : 1                              |
; |   Release   : 0                              |
; |   Autore    : Lain Walter                    |
; |   Data      :  7/08/07                       |
; |______________________________________________|

Keyb_Read:
;Questa routine legge i pulsanti
; Sono necessari 4 bytes come buffer e 1 byte di controllo
;Registri modificati:
;       sistema
;       b_SW1_BUFF
;       b_SW2_BUFF
;       b_SW3_BUFF
;       b_SW4_BUFF
;       b_SW_CTRL
;       b_DISP_SEL
;       b_STATO
;       b_DISP_DATA0,1,2,3
;metodo di chiamata:
;       CALL Keyb_Read
;
SW0_TST BTFSS c_SW_ST_PORT,c_SW_ST_PIN  ;controlla se tasto "start/stop" premuto
        GOTO SW0_SET                    ; si, salta
SW0_CLR MOVF b_SW4_BUFF,W               ;no, controlla se buffer a 0
        BZ SW_CTR                       ; si, tasto già rilasciato, non fa niente
        DECFSZ b_SW4_BUFF,F             ;no, decrementa buffer
        GOTO SW_CTR                     ; non è a 0, non fa niente
        BCF f_SW_STST_STAT              ;è a 0, clear flag stato
        BSF f_SW_STST_CHG               ;set flag cambio stato
        GOTO SW_CTR                     ;fine controllo
SW0_SET BTFSC b_SW4_BUFF,c_SW_BIT       ; controlla se buffer a livello
        GOTO SW_CTR                     ; si, tasto già premuto, non fa niente
        INCF b_SW4_BUFF,F               ; no, incrementa buffer
        BTFSS b_SW4_BUFF,c_SW_BIT       ; controlla se buffer a livello
        GOTO SW_CTR                     ; no, non fa niente
        BSF f_SW_STST_STAT              ;si, set flag stato
        BSF f_SW_STST_CHG               ;set flag cambio stato

SW_CTR  BTFSC f_FIRST                   ;controlla se attivo pulsante "select"
        GOTO SW1_TST                    ; si
        BTFSC f_SECOND                  ;no, controlla se attivo pulsante "add"
        GOTO SW2_TST                    ; si
        BTFSC f_THIRD                   ;controlla se attivo pulsante "sub"
        GOTO SW3_TST                    ; si
        GOTO SW_END                     ;nessun pulsante attivo, esce
SW1_TST BTFSS c_SW_IN_PORT,c_SW_IN_PIN  ;controlla se tasto "select" premuto
        GOTO SW1_SET                    ; si, salta
SW1_CLR MOVF b_SW1_BUFF,W               ;no, controlla se buffer a 0
        BZ SW_END                       ; si, tasto già rilasciato, non fa niente
        DECFSZ b_SW1_BUFF,F             ;no, decrementa buffer
        GOTO SW_END                     ; non è a 0, non fa niente
        BCF f_SW_SEL_STAT               ;è a 0, clear flag stato
        BSF f_SW_SEL_CHG                ;set flag cambio stato
        GOTO SW_END                     ;fine controllo
SW1_SET BTFSC b_SW1_BUFF,c_SW_BIT       ; controlla se buffer a livello
        GOTO SW_END                     ; si, tasto già premuto, non fa niente
        INCF b_SW1_BUFF,F               ; no, incrementa buffer
        BTFSS b_SW1_BUFF,c_SW_BIT       ; controlla se buffer a livello
        GOTO SW_END                     ; no, non fa niente
        BSF f_SW_SEL_STAT               ;si, set flag stato
        BSF f_SW_SEL_CHG                ;set flag cambio stato
        GOTO SW_END
SW2_TST BTFSS c_SW_IN_PORT,c_SW_IN_PIN  ;controlla se tasto "add" premuto
        GOTO SW2_SET                    ; si, salta
SW2_CLR MOVF b_SW2_BUFF,W               ;no, controlla se buffer a 0
        BZ SW_END                       ; si, tasto già rilasciato, non fa niente
        DECFSZ b_SW2_BUFF,F             ;no, decrementa buffer
        GOTO SW_END                     ; non è a 0, non fa niente
        BCF f_SW_ADD_STAT               ;è a 0, clear flag stato
        BSF f_SW_ADD_CHG                ;set flag cambio stato
        GOTO SW_END                     ;fine controllo
SW2_SET BTFSC b_SW2_BUFF,c_SW_BIT       ; controlla se buffer a livello
        GOTO SW_END                     ; si, tasto già premuto, non fa niente
        INCF b_SW2_BUFF,F               ; no, incrementa buffer
        BTFSS b_SW2_BUFF,c_SW_BIT       ; controlla se buffer a livello
        GOTO SW_END                     ; no, non fa niente
        BSF f_SW_ADD_STAT               ;si, set flag stato
        BSF f_SW_ADD_CHG                ;set flag cambio stato
        GOTO SW_END
SW3_TST BTFSS c_SW_IN_PORT,c_SW_IN_PIN  ;controlla se tasto "sub" premuto
        GOTO SW3_SET                    ; si, salta
SW3_CLR MOVF b_SW3_BUFF,W               ;no, controlla se buffer a 0
        BZ SW_END                       ; si, tasto già rilasciato, non fa niente
        DECFSZ b_SW3_BUFF,F             ;no, decrementa buffer
        GOTO SW_END                     ; non è a 0, non fa niente
        BCF f_SW_SUB_STAT               ;è a 0, clear flag stato
        BSF f_SW_SUB_CHG                ;set flag cambio stato
        GOTO SW_END                     ;fine controllo
SW3_SET BTFSC b_SW3_BUFF,c_SW_BIT       ; controlla se buffer a livello
        GOTO SW_END                     ; si, tasto già premuto, non fa niente
        INCF b_SW3_BUFF,F               ; no, incrementa buffer
        BTFSS b_SW3_BUFF,c_SW_BIT       ; controlla se buffer a livello
        GOTO SW_END                     ; no, non fa niente
        BSF f_SW_SUB_STAT               ;si, set flag stato
        BSF f_SW_SUB_CHG                ;set flag cambio stato
SW_END  CALL Select_Sw                  ;chiama sub selezione display
        CALL Add_Sw                     ;chiama sub incremento display
        CALL Sub_Sw                     ;chiama sub decremento display
        RETURN                          ;fine


Select_Sw:
;Seleziona ciclicamente i vari display e cambia la modalità di lavoro
; in base alla pressione del pulsante "select"
;Registri modificati:
;       sistema
;       b_DISP_SEL
;       b_STATO
;metodo di chiamata:
;       CALL Select_Sw
;
        BTFSS f_INIT                    ;controlla se in init
        RETURN                          ; no, non fa niente
        BTFSS f_SW_SEL_STAT             ;verifica se pulsante premuto
        RETURN                          ; no, esce
        BTFSS f_SW_SEL_CHG              ;si, verifica cambio stato
        RETURN                          ; no, esce
        BCF f_SW_SEL_CHG
        BTFSC f_DISP0_SEL               ;controlla quale display è selezionato
        GOTO SLW_100                    ;display 0
        BTFSC f_DISP1_SEL
        GOTO SLW_200                    ;display 1
        BTFSC f_DISP2_SEL
        GOTO SLW_300                    ;display 2
        BTFSC f_DISP3_SEL
        GOTO SLW_400                    ;display 3
        RETURN                          ;errore, esce
SLW_100 BCF f_DISP0_SEL                 ;seleziona display 1
        BSF f_DISP1_SEL
        RETURN
SLW_200 BCF f_DISP1_SEL                 ;seleziona display 2
        BSF f_DISP2_SEL
        RETURN
SLW_300 BCF f_DISP2_SEL                 ;seleziona display 3
        BSF f_DISP3_SEL
        RETURN
SLW_400 BCF f_DISP3_SEL                 ;seleziona display 0
        BSF f_DISP0_SEL
        BTFSC f_MODE                    ;fa un toggle del modo
        GOTO $+3                        ;(passa da secondi a minuti
        BSF f_MODE                      ; e viceversa)
        GOTO $+2
        BCF f_MODE
        RETURN

Add_Sw:
;Incrementa i display
; in base alla pressione del pulsante "add"
;Registri modificati:
;       sistema
;       b_DISP_DATA0,1,2,3
;metodo di chiamata:
;       CALL Add_Sw
;
        BTFSS f_INIT                    ;controlla se in init
        RETURN                          ; no, non fa niente
        BTFSS f_SW_ADD_STAT             ;verifica se pulsante premuto
        RETURN                          ; no, esce
        BTFSS f_SW_ADD_CHG              ;si, verifica cambio stato
        RETURN                          ; no, esce
        BCF f_SW_ADD_CHG
        BTFSC f_DISP0_SEL               ;controlla quale display è selezionato
        GOTO SLA_100                    ;display 0
        BTFSC f_DISP1_SEL
        GOTO SLA_200                    ;display 1
        BTFSC f_DISP2_SEL
        GOTO SLA_300                    ;display 2
        BTFSC f_DISP3_SEL
        GOTO SLA_400                    ;display 3
        RETURN                          ;errore, esce
SLA_100 INCF b_DISP_DATA0,F             ;incrementa valore display
        MOVLW .11
        SUBWF b_DISP_DATA0,W            ;verifica che il valore non sia maggiore di 9
        BNC SLA_101
        MOVLF .1,b_DISP_DATA0           ;se maggiore di 9 allora diventa 0
SLA_101 RETURN
SLA_200 INCF b_DISP_DATA1,F             ;incrementa valore display
        MOVLW .11
        SUBWF b_DISP_DATA1,W            ;verifica che il valore non sia maggiore di 9
        BNC SLA_201
        MOVLF .1,b_DISP_DATA1           ;se maggiore di 9 allora diventa 0
SLA_201 RETURN
SLA_300 INCF b_DISP_DATA2,F             ;incrementa valore display
        MOVLW .11
        SUBWF b_DISP_DATA2,W            ;verifica che il valore non sia maggiore di 9
        BNC SLA_301
        MOVLF .1,b_DISP_DATA2           ;se maggiore di 9 allora diventa 0
SLA_301 RETURN
SLA_400 INCF b_DISP_DATA3,F             ;incrementa valore display
        MOVLW .11
        SUBWF b_DISP_DATA3,W            ;verifica che il valore non sia maggiore di 9
        BNC SLA_401
        MOVLF .1,b_DISP_DATA3           ;se maggiore di 9 allora diventa 0
SLA_401 RETURN

Sub_Sw:
;Decrementa i display
; in base alla pressione del pulsante "add"
;Registri modificati:
;       sistema
;       b_DISP_DATA0,1,2,3
;metodo di chiamata:
;       CALL Sub_Sw
;
        BTFSS f_INIT                    ;controlla se in init
        RETURN                          ; no, non fa niente
        BTFSS f_SW_SUB_STAT             ;verifica se pulsante premuto
        RETURN                          ; no, esce
        BTFSS f_SW_SUB_CHG              ;si, verifica cambio stato
        RETURN                          ; no, esce
        BCF f_SW_SUB_CHG
        BTFSC f_DISP0_SEL               ;controlla quale display è selezionato
        GOTO SLS_100                    ;display 0
        BTFSC f_DISP1_SEL
        GOTO SLS_200                    ;display 1
        BTFSC f_DISP2_SEL
        GOTO SLS_300                    ;display 2
        BTFSC f_DISP3_SEL
        GOTO SLS_400                    ;display 3
        RETURN                          ;errore, esce
SLS_100 DECF b_DISP_DATA0,F             ;decrementa valore display
        BNZ SLS_101                     ;verifica che il valore non sia minore di 0
        MOVLF .10,b_DISP_DATA0          ;se minore di 0 allora diventa 9
SLS_101 RETURN
SLS_200 DECF b_DISP_DATA1,F             ;decrementa valore display
        BNZ SLS_201                     ;verifica che il valore non sia minore di 0
        MOVLF .10,b_DISP_DATA1          ;se minore di 0 allora diventa 9
SLS_201 RETURN
SLS_300 DECF b_DISP_DATA2,F             ;decrementa valore display
        BNZ SLS_301                     ;verifica che il valore non sia minore di 0
        MOVLF .10,b_DISP_DATA2          ;se minore di 0 allora diventa 9
SLS_301 RETURN
SLS_400 DECF b_DISP_DATA3,F             ;decrementa valore display
        BNZ SLS_401                     ;verifica che il valore non sia minore di 0
        MOVLF .10,b_DISP_DATA3          ;se minore di 0 allora diventa 9
SLS_401 RETURN

